# Generated by Django 3.1.7 on 2021-03-24 18:03

from django.db import migrations, models
import django.db.models.deletion


def create_count_event_category(apps, schema_editor):
    EventCategory = apps.get_model("api", "EventCategory")
    count_event_category = EventCategory(name="count")
    count_event_category.save()


class Migration(migrations.Migration):

    initial = True

    dependencies = []

    operations = [
        migrations.CreateModel(
            name="Colony",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("founded_on", models.DateTimeField()),
            ],
            options={
                "verbose_name": "colony",
                "verbose_name_plural": "colonies",
            },
        ),
        migrations.CreateModel(
            name="Event",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("created_on", models.DateTimeField(auto_now=True)),
                ("notes", models.TextField(blank=True)),
            ],
            options={
                "verbose_name": "event",
                "verbose_name_plural": "events",
            },
        ),
        migrations.CreateModel(
            name="EventCategory",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(max_length=255)),
            ],
            options={
                "verbose_name": "event category",
                "verbose_name_plural": "event categories",
            },
        ),
        migrations.CreateModel(
            name="Count",
            fields=[
                (
                    "event_ptr",
                    models.OneToOneField(
                        auto_created=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        parent_link=True,
                        primary_key=True,
                        serialize=False,
                        to="api.event",
                    ),
                ),
                ("workers", models.IntegerField()),
                ("brood", models.IntegerField()),
            ],
            options={
                "verbose_name": "count",
                "verbose_name_plural": "counts",
            },
            bases=("api.event",),
        ),
        migrations.CreateModel(
            name="Taxon",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("family", models.CharField(blank=True, max_length=255)),
                ("subfamily", models.CharField(blank=True, max_length=255)),
                ("tribe", models.CharField(blank=True, max_length=255)),
                ("genus", models.CharField(blank=True, max_length=255)),
                ("species", models.CharField(blank=True, max_length=255)),
                ("subspecies", models.CharField(blank=True, max_length=255)),
            ],
            options={
                "verbose_name": "taxon",
                "verbose_name_plural": "taxa",
                "unique_together": {
                    ("family", "subfamily", "tribe", "genus", "species", "subspecies")
                },
            },
        ),
        migrations.AddField(
            model_name="event",
            name="category",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.PROTECT,
                related_name="events",
                to="api.eventcategory",
            ),
        ),
        migrations.AddField(
            model_name="event",
            name="colony",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE,
                related_name="events",
                to="api.colony",
            ),
        ),
        migrations.AddField(
            model_name="colony",
            name="taxon",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.PROTECT,
                related_name="colonies",
                to="api.taxon",
            ),
        ),
        migrations.RunPython(create_count_event_category),
    ]
